/* simple password generator by Nelson Minar (minar@reed.edu)
 * copyright 1991, all rights reserved.
 * You can use this code as long as my name stays with it.
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#ifndef _WIN32
#include "../../config/setup.h"
#else /* _WIN32 */
#include "crypt.h"
#include "config-win32.h"
#include <conio.h>
#include <crypt.h>
#define random()   rand()
#define srandom(x) srand(x)
#endif  /* _WIN32 */

#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#if STDC_HEADERS
# include <string.h>
#else
# ifndef HAVE_STRCHR
#  define strchr index
# endif
char *strchr();
#endif

#ifndef _WIN32
extern char *getpass();
#else
#define GETPASS_MAX 32
char* getpass(const char* prompt)
{
  static char buf[GETPASS_MAX + 1];
  int nchar = 0;

  printf(prompt);
  while (nchar < GETPASS_MAX) {
    buf[nchar] = getch();
    if (buf[nchar] == '\n' || buf[nchar] == '\r') {
      buf[nchar] = 0;
      break;
    }
    ++nchar;
  }
  putch('\n');
  return buf;
}
#endif /* WIN32 */

int main(int argc, char *argv[])
{
  static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
  char salt[3];
  char * plaintext;

  if (argc < 2) {
    srandom(time(0));		/* may not be the BEST salt, but its close */
    salt[0] = saltChars[random() % 64];
    salt[1] = saltChars[random() % 64];
    salt[2] = 0;
  }
  else {
    salt[0] = argv[1][0];
    salt[1] = argv[1][1];
    salt[2] = '\0';
    if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
      fprintf(stderr, "illegal salt %s\n", salt), exit(1);
  }

  plaintext = getpass("plaintext: ");

  printf("%s\n", crypt(plaintext, salt));
  return 0;
}

